#ifndef FRIIO_H
#define FRIIO_H 1

#include <stdint.h>

#define USB_DIR_IN        0x80            /* to host */
#define USB_DIR_OUT       0               /* to device */
#define USB_TYPE_VENDOR   (0x02 << 5)
#define USB_RECIP_DEVICE  0x00

typedef struct _usb_control_req {
	uint8_t  bmRequestType;
	uint8_t  bRequest;
	uint16_t wValue;
	uint16_t wIndex;
	uint16_t wLength;
} usb_control_req;

/* ξ */
typedef struct _arginfo {
	int   packetcount;
	const char *vender;
	const char *id;
	int   num;
	int   waittime;
	int   channel;
	int   recsec;
	const char *outname;
	int   bscs;
	int   rtpri;
} arginfo;

#ifdef __cplusplus
extern "C"{
#endif /* __cplusplus */

	void ArgInit(arginfo *ainfo);

	void PriorityControl(arginfo *ainfo);

	int UsbOpen(const char *vender, const char *id, int num);

	int UsbControlRequst(usb_control_req *req, uint8_t *buf, size_t bsize);
	int UsbReciveIsoc(int *endcheck, FILE *outfile, int packetcount);

	int UsbClose();

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* FRIIO_H */
