#! /bin/sh
tsfile=/bigdata/test.ts
logfile=/tmp/frrecbs.log
priocmd="priocntl -e -c RT -p 1 "
friiocmd="/tmp/frrec -b -n 1 "
rectime=1800
tscmd=/tmp/tsselect
epgfile=/tmp/epgbs.txt
epgcmd=/tmp/epgdump
epgsort="sort -t, +1n -2 +2n -3 +3n -4 -u -o $epgfile $epgfile"

cat /dev/null > $logfile
cat /dev/null > $epgfile

#
#  13 : BS-Asahi      24 : 110CS #1
#  14 : BS-i          25 : 110CS #2
#  15 : WOWOW         26 : 110CS #3
#  16 : BS-Japan      27 : 110CS #4
#  17 : BS11          28 : 110CS #5
#  18 : Star Channel  29 : 110CS #6
#  19 : TwellV        30 : 110CS #7
#  20 : BS-NTV        31 : 110CS #8
#  21 : BS-Fuji       32 : 110CS #9
#  22 : NHK BS1/BS2   33 : 110CS #a
#  23 : NHK hi        34 : 110CS #b
#                     35 : 110CS #c

while test -f $logfile; do
    echo "BS-Asahi" >> $logfile
    date  >> $logfile
    $priocmd $friiocmd 13 $rectime $tsfile >> $logfile 2>&1
    date  >> $logfile
    $tscmd $tsfile >> $logfile
    $epgcmd -l $tsfile >> $epgfile
    $epgsort

    echo "BS-i" >> $logfile
    date  >> $logfile
    $priocmd $friiocmd 14 $rectime $tsfile >> $logfile 2>&1
    date  >> $logfile
    $tscmd $tsfile >> $logfile
    $epgcmd -l $tsfile >> $epgfile
    $epgsort

    echo "WOWOW" >> $logfile
    date  >> $logfile
    $priocmd $friiocmd 15 $rectime $tsfile >> $logfile 2>&1
    date  >> $logfile
    $tscmd $tsfile >> $logfile
    $epgcmd -l $tsfile >> $epgfile
    $epgsort

    echo "BS-Japan" >> $logfile
    date  >> $logfile
    $priocmd $friiocmd 16 $rectime $tsfile >> $logfile 2>&1
    date  >> $logfile
    $tscmd $tsfile >> $logfile
    $epgcmd -l $tsfile >> $epgfile
    $epgsort

    echo "BS11" >> $logfile
    date  >> $logfile
    $priocmd $friiocmd 17 $rectime $tsfile >> $logfile 2>&1
    date  >> $logfile
    $tscmd $tsfile >> $logfile
    $epgcmd -l $tsfile >> $epgfile
    $epgsort

    echo "Star Channel" >> $logfile
    date  >> $logfile
    $priocmd $friiocmd 18 $rectime $tsfile >> $logfile 2>&1
    date  >> $logfile
    $tscmd $tsfile >> $logfile
    $epgcmd -l $tsfile >> $epgfile
    $epgsort

    echo "TwellV" >> $logfile
    date  >> $logfile
    $priocmd $friiocmd 19 $rectime $tsfile >> $logfile 2>&1
    date  >> $logfile
    $tscmd $tsfile >> $logfile
    $epgcmd -l $tsfile >> $epgfile
    $epgsort

    echo "BS-NTV" >> $logfile
    date  >> $logfile
    $priocmd $friiocmd 20 $rectime $tsfile >> $logfile 2>&1
    date  >> $logfile
    $tscmd $tsfile >> $logfile
    $epgcmd -l $tsfile >> $epgfile
    $epgsort

    echo "BS-Fuji" >> $logfile
    date  >> $logfile
    $priocmd $friiocmd 21 $rectime $tsfile >> $logfile 2>&1
    date  >> $logfile
    $tscmd $tsfile >> $logfile
    $epgcmd -l $tsfile >> $epgfile
    $epgsort

    echo "NHK BS1/BS2" >> $logfile
    date  >> $logfile
    $priocmd $friiocmd 22 $rectime $tsfile >> $logfile 2>&1
    date  >> $logfile
    $tscmd $tsfile >> $logfile
    $epgcmd -l $tsfile >> $epgfile
    $epgsort

    echo "NHK hi" >> $logfile
    date  >> $logfile
    $priocmd $friiocmd 23 $rectime $tsfile >> $logfile 2>&1
    date  >> $logfile
    $tscmd $tsfile >> $logfile
    $epgcmd -l $tsfile >> $epgfile
    $epgsort

done
