#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include <string.h>
#include <unistd.h>
#include <fcntl.h>

#include <pwd.h>
#include <sys/types.h>
#include <sys/priocntl.h>
#include <sys/rtpriocntl.h>

#include "friio.h"

#include <sys/usb/clients/ugen/usb_ugen.h>

static void init_cntrl_req(uchar_t *req, 
						   uchar_t bmRequestType, uchar_t bRequest,
						   ushort_t wValue, ushort_t wIndex, ushort_t wLength);

static int ctlfd;
static int ctlstatfd;

void ArgInit(arginfo *ainfo) {

	ainfo->packetcount = 8;
	//ainfo->packetcount = 200;
	ainfo->vender = "7a69";
	ainfo->id  = "1";
	ainfo->num = 0;
	
	/*
	  ainfo->channel = 10;
	  ainfo->recsec  = 600; 10min
	  ainfo->outname = "/tmp/test.ts";
	*/

}

void PriorityControl(arginfo *ainfo) {
	struct passwd *pw;
	uid_t root_uid;
	gid_t root_gid;

	uid_t my_uid;
	gid_t my_gid;
	
	/*
	pcinfo_t ci;
	pcparms_t sp;
	*/
	rtparms_t rp;
	long rc;

	/* ¹Ը¤롼Ȥˤpriocntl */
	my_uid = getuid();
	my_gid = getgid();

	setpwent();
	if((pw = getpwnam("root")) == NULL) {
		fprintf(stderr,"passwd root get faild\n");
		return;
	}
	endpwent();
	
	root_uid = pw->pw_uid;
	root_gid = pw->pw_gid;

	
	/* ѥ桼ˤʤ */
	if(setgid(root_gid) < 0) {
		fprintf(stderr,"setgid faild\n");
		return;
	}
	if(setuid(root_uid) < 0) {
		fprintf(stderr,"setuid faild\n");
		return;
	}

	/*
	memset(&ci, 0, sizeof(pcinfo_t));
	strcpy(ci.pc_clname, "RT");
	rc = priocntl(0, 0, PC_GETCID, &ci);
	*/

	memset(&rp, 0, sizeof(rtparms_t));
	rp.rt_pri = ainfo->rtpri;

	/*
	memset(&sp, 0, sizeof(pcparms_t));
	memset(&rp, 0, sizeof(rtparms_t));
	sp.pc_cid = ci.pc_cid;
	rp.rt_pri = ainfo->rtpri;
	
	memcpy(sp.pc_clparms, &rp, sizeof(rtparms_t));
	
	rc = priocntl(P_PID, getpid(), PC_SETPARMS, &sp);
	*/
	rc = priocntl(P_LWPID, P_MYID, PC_SETXPARMS, "RT", RT_KY_PRI, rp.rt_pri, NULL);
	if(rc < 0) {
		fprintf(stderr,"priocntl faild errno:%d\n", errno);
	}

	/* ᤹ */
	if(setgid(my_gid) < 0) {
		fprintf(stderr,"setgid faild\n");
		return;
	}
	if(setuid(my_uid) < 0) {
		fprintf(stderr,"setuid faild\n");
		return;
	}

}


#define MAX_DEVNAME 1024

static char isocdevname[MAX_DEVNAME];

int UsbOpen(const char *vender, const char *id, int num) {
	char devname[MAX_DEVNAME];
  
	sprintf(devname, "/dev/usb/%s.%s/%d/cntrl0", vender, id, num);
	ctlfd = open(devname, O_RDWR);

	sprintf(devname, "/dev/usb/%s.%s/%d/cntrl0stat", vender, id, num);
	ctlstatfd = open(devname, O_RDONLY);

	sprintf(isocdevname, "/dev/usb/%s.%s/%d/if0.1in1", vender, id, num);

}

int UsbClose() {
	close(ctlstatfd);
	close(ctlfd);
}

int UsbControlRequst(usb_control_req *ureq, uint8_t *buf, size_t bsize) {
	uchar_t *req;
	int count;
	int len;
  
	if(ureq->bmRequestType & USB_DIR_IN || bsize == 0) {
		len = 8;
		req = malloc(sizeof(uchar_t) * len);

		init_cntrl_req(req, ureq->bmRequestType,
					   ureq->bRequest, ureq->wValue, ureq->wIndex,
					   ureq->wLength);
	} else {
		len = 8 + bsize;
    
		req = malloc(sizeof(uchar_t) * len);
		init_cntrl_req(req, ureq->bmRequestType,
					   ureq->bRequest, ureq->wValue, ureq->wIndex,
					   ureq->wLength);
		memcpy(&req[8], buf, bsize);
	}
  
	count = write(ctlfd, req, len);
  
	free(req);
  
	if(count != len) {
		if (-1 == count) {
			int status;

			fprintf(stderr, "control transfer faild\n");
			read(ctlstatfd, &status, sizeof(status));
			switch(status) {
			case USB_LC_STAT_NOERROR:
				fprintf(stderr, "No error\n");
				break;
			case USB_LC_STAT_CRC:
				fprintf(stderr, "CRC timeout detected   \n");
				break;
			case USB_LC_STAT_BITSTUFFING:
				fprintf(stderr, "Bit-stuffing violation \n");
				break;
			case USB_LC_STAT_DATA_TOGGLE_MM:
				fprintf(stderr, "Data toggle mismatch  \n");
				break;
			case USB_LC_STAT_STALL:
				fprintf(stderr, "Endpoint stalled\n");
				break;
			case USB_LC_STAT_DEV_NOT_RESP:
				fprintf(stderr, "Device not responding\n");
				break;
			case USB_LC_STAT_PID_CHECKFAILURE:
				fprintf(stderr, "PID Check failure\n");
				break;
			case USB_LC_STAT_UNEXP_PID:
				fprintf(stderr, "Unexpected PID\n");
				break;
			case USB_LC_STAT_DATA_OVERRUN:
				fprintf(stderr, "Data size exceeded\n");
				break;
			case USB_LC_STAT_DATA_UNDERRUN:
				fprintf(stderr, "Less data received\n");
				break;
			case USB_LC_STAT_BUFFER_OVERRUN:
				fprintf(stderr, "Buffer size exceeded\n");
				break;
			case USB_LC_STAT_BUFFER_UNDERRUN:
				fprintf(stderr, "Buffer under run\n");
				break;
			case USB_LC_STAT_TIMEOUT:
				fprintf(stderr, "Command timed out\n");
				break;
			case USB_LC_STAT_NOT_ACCESSED:
				fprintf(stderr, "Not accessed by h/w\n");
				break;
			case USB_LC_STAT_UNSPECIFIED_ERR:
				fprintf(stderr, "Unspecified error\n");
				break;
			case USB_LC_STAT_NO_BANDWIDTH:
				fprintf(stderr, "No bandwidth\n");
				break;
			case USB_LC_STAT_HW_ERR:
				fprintf(stderr, "Hardware error\n");
				break;
			case USB_LC_STAT_SUSPENDED:
				fprintf(stderr, "Device suspended/resumed\n");
				break;
			case USB_LC_STAT_DISCONNECTED:
				fprintf(stderr, "Device disconnected\n");
				break;
			case USB_LC_STAT_INTR_BUF_FULL:
				fprintf(stderr, "Interrupt buf was full\n");
				break;
			case USB_LC_STAT_INVALID_REQ:
				fprintf(stderr, "request was invalid\n");
				break;
			case USB_LC_STAT_INTERRUPTED:
				fprintf(stderr, "request was interrupted\n");
				break;
			case USB_LC_STAT_NO_RESOURCES:
				fprintf(stderr, "no resources for req\n");
				break;
			case USB_LC_STAT_INTR_POLLING_FAILED:
				fprintf(stderr, "failed to restart poll\n");
				break;
			}
			return -1;
		}
	}
    
	if(ureq->bmRequestType & USB_DIR_IN && bsize != 0) {
		/* ɤ */
		len = bsize;
		char *recv = malloc(sizeof(uchar_t) * len);
		count = read(ctlfd, recv, len);
		if(count != len) {
			return -1;
		}
		memcpy(buf, recv, bsize);
		free(recv);
	}

	return count;

}

#define BUFLEN 3072
//#define BUFLEN 1024

int UsbReciveIsoc(int *endcheck, FILE *outfd, int packetcount) {
	int count;

	char *buf, *p;
	ushort_t  pktlen = BUFLEN;
	int pktcnt, i;
	int csize = 0;
	int len, rlen;
	ugen_isoc_req_head_t *req;
	ugen_isoc_pkt_descr_t *pktdesc;

	char *rdbuf;

	int isocfd;
  
	isocfd = open(isocdevname, O_RDWR);

	pktcnt = packetcount; 
  
	len = sizeof(int) + sizeof(ugen_isoc_pkt_descr_t) * pktcnt;
  
	buf = malloc(len);
	memset(buf, 0, len);
  
	req = (ugen_isoc_req_head_t *)buf;
	req->req_isoc_pkts_count = pktcnt;
  
	pktdesc = (ugen_isoc_pkt_descr_t *)(req->req_isoc_pkt_descrs);
  
	req->req_isoc_pkts_count = pktcnt;
  
	for (i = 0; i < pktcnt; i++) {
		/*
		 * pktlen should not exceed xfer
		 * capability of an endpoint
		 */
		pktdesc[i].dsc_isoc_pkt_len = pktlen; 
    
		pktdesc[i].dsc_isoc_pkt_actual_len = 0;
		pktdesc[i].dsc_isoc_pkt_status = 0;
	}
  
	/*
	 * write request info to driver and len must
	 * be exactly the sum of
	 * sizeof(int) + sizeof(ugen_isoc_pkt_descr_t) * pktcnt.
	 * Otherwise, an error is returned.
	 */
	if (write(isocfd, buf, len) < 0) {
		fprintf(stderr, "failed to TS write\n");
		return -1;
	} 
    
	rlen = (sizeof(ugen_isoc_pkt_descr_t) + pktlen) * pktcnt;
	rdbuf = malloc(rlen);

	while(1) {
    
		memset(rdbuf, 0, rlen);
    
		/*
		 * Read length should be sum of all pkt descriptors
		 * length + payload data length of all pkts
		 * (sizeof(ugen_isoc_pkt_descr_t) + pktlen) * pktcnt
		 */
		if ((count = read(isocfd, rdbuf, rlen)) < 0) {
			fprintf(stderr, "failed to TS read\n");
			return -1;
		}
		// printf("r count = %d\n", count);
    
		pktdesc = (ugen_isoc_pkt_descr_t *) rdbuf;
    
		/* points to payload beginning */
		p = rdbuf + (pktcnt * sizeof(ugen_isoc_pkt_descr_t));
    
		for (i = 0; i < pktcnt; i++) {
			if(pktdesc->dsc_isoc_pkt_actual_len > 2) {
				count = fwrite(p+2, pktdesc->dsc_isoc_pkt_actual_len-2, 1, outfd);
				if(count == -1) {
					printf("failed to TS write\n");
					break;
				}
				csize += (pktdesc->dsc_isoc_pkt_actual_len-2);
			}

			/*
			 * next packet data payload, do NOT use
			 * dsc_isoc_pkt_actual_len
			 */
			p += pktdesc->dsc_isoc_pkt_len; 
      
			pktdesc++;
      
		}
    
		if(*endcheck == 1) {
			break;
		}
	}

	close(isocfd);

#ifdef DUMPUSB
	system("/tmp/dumpusb.sh");
#endif

	return 0;
    
}

void init_cntrl_req(uchar_t *req, uchar_t bmRequestType, uchar_t bRequest,
					ushort_t wValue, ushort_t wIndex, ushort_t wLength) {
	req[0] = bmRequestType;
	req[1] = bRequest;
	req[2] = 0xFF & wValue;
	req[3] = 0xFF & (wValue >> 8);
	req[4] = 0xFF & wIndex;
	req[5] = 0xFF & (wIndex >> 8);
	req[6] = 0xFF & wLength;
	req[7] = 0xFF & (wLength >> 8);
}
